// C Header File
// Created 26/10/2002; 15:01:27
// copyright 2002 Thibaut Chevalier

// Constantes du programme + inclusions gnrales

/***************************************************************************************************/
// Faire le choix de la compilation ICI :
#define COMPILE_FOR_TI92PLUS
/***************************************************************************************************/

#ifdef COMPILE_FOR_TI89
	#define USE_TI89              // Compile for TI-89
#endif

#ifdef COMPILE_FOR_TI92PLUS
	#define USE_TI92PLUS          // Compile for TI-92+
	#define USE_V200							// Compile for V200
#endif

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 100           // Compile for AMS 1.00 or higher
#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // inclut les fichier de la lib tigcc

#define CODE_SHIP 21251

#define XOFFSET (CALCULATOR?40:0)	// pour centrer le texte sur la TI92+ et V200
#define SPEOFFSET (CALCULATOR?75:0)
#define YOFFSET (CALCULATOR?12:0)

#define MAX_MISSILES 10 // nombre max de missiles volant simultanment
#define MISSILE_SPEED 8 // norme du vecteur entre deux positions du missile

#define PERIODE_GAIN_MISSILE 250 // nombre de pas au bout duquel un missile guid est ajout  la liste
#define FULL_STOCK 5	// nombre maximum de missile guid qu'il est possible d'avoir en stock

enum {PRESENT = 1, ABSENT, EXPLOSE, KAMIKAZE};

#define KAM_PERIODE 8		// priode (approximative d'apparition d'un droide kamikaze)
#define RING_NB 20			// 20 anneaux en mode training

#define MAX_TEXT_LINES 8	 // maximum de lignes dans une structure text 
#define MEM_ERROR 1				 // argument pass  la fonction exit_proc en cas d'erreur dans un malloc

#define INIT_TIE ship_set(ship, -100 + (200 * ship), -5, -70, 0, 128, 0)

typedef struct
	{
 	short linesNum;
 	const char* message[MAX_TEXT_LINES];
 	short coord[MAX_TEXT_LINES][2];
	} TextPage;
	
#define REAL_MENUS_NB 3

typedef struct
	{
	TextPage* ptrTextPage;
	const char* statusBarText[6];
	short links[6];
	} MenuItem;
	
// identificateurs des menus terminaux (FINISH)
enum {EMPTY = -1, MAIN_MENU_ID, PLAY_MENU_ID, OPTIONS_MENU_ID, CONTROLS_MENU_ID, HIGH_MENU_ID, CREDITS_MENU_ID, EXIT_MENU_ID, REPLAY_MENU_ID, TRAINING_MENU_ID, COMPET_MENU_ID, CHGNAME_MENU_ID, CTMOD_MENU_ID, TRAJ_MENU_ID, DEF_CAM_MENU_ID};


typedef struct
 	{
 		char playerName[11];
 		short controlsMode;	// arcade / simulation
 		short trajMode;    // lignes / spirales
 		short cameraMode; // fixe / accroche au vaisseau
 	} DATA2SAVE;
 	
/***************** Structure unit highscores *****************/

typedef struct
	{
		char ptrName[11];
		long score;
	} HSC_ITEM;

/***************** Modes du jeu ********************************/
enum {TRAINING, COMPET}; // modes de jeu
enum {FIX = 1, MOBILE}; // modes de camra
enum {ARCADE = 1, SIM}; // mode de jeu (contrles)
enum {LINE = 1, SPIRAL}; // mode de trajectoire des astroides

/************ Structures relatives  la 3D *********************/

// structure pour un vertex (point 3D)
typedef struct
{
  int x;
  int y;
  int z;
} Vertex;

// structure pour un point  l'cran (point 3D)
typedef struct
{
  int x;
  int y;     
} ScrPoint;

// Structure contenant les infos sur une ligne : c'est  dire les numros des points qui en sont les bouts
typedef struct
{
	int point1;
	int point2;
} Line;

// structure qui contient les trois angles d'un objet
typedef struct
{
	unsigned char x;
	unsigned char y;
	unsigned char z;
} Angle;
/*****************************************************************/